/* $Id: sc.c,v 0.6 2003/01/27 18:48:21 folkert Exp folkert $
 * $Log: sc.c,v $
 * Revision 0.6  2003/01/27 18:48:21  folkert
 * initial RCS check-in
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <linux/videodev.h>
#include <ppm.h>
#include "sc.h"

int open_device(vconfig *vconf, char *dev_name, char res)
{
	vconf -> fd = open(dev_name, O_RDONLY);
	if (vconf -> fd == -1)
	{
		perror("open");
		return -1;
	}

	/* get parameters */
	if (ioctl(vconf -> fd, VIDIOCGPICT, &vconf -> vidpic, sizeof(vconf -> vidpic)) == -1)
	{
		perror("VIDIOCGPICT");
		return -1;
	}

	/* get capabilities */
	if (ioctl(vconf -> fd, VIDIOCGCAP, &vconf -> vidcap, sizeof(vconf -> vidcap)) == -1)
	{
		perror("VIDIOCGCAP");
		return -1;
	}

	/* set capture window */
	if (ioctl(vconf -> fd, VIDIOCGWIN, &vconf -> vidwin, sizeof(vconf -> vidwin)) == -1)
	{
		perror("VIDIOCGWIN");
		return -1;
	}
	vconf -> vidwin.x =
	vconf -> vidwin.y = 0;
	if (res == RES_LOW)
	{
		vconf -> vidwin.width = vconf -> vidcap.minwidth;
		vconf -> vidwin.height = vconf -> vidcap.minheight;
	}
	else if (res == RES_HIGH)
	{
		vconf -> vidwin.width = vconf -> vidcap.maxwidth;
		vconf -> vidwin.height = vconf -> vidcap.maxheight;
	}
	if (ioctl(vconf -> fd, VIDIOCSWIN, &vconf -> vidwin, sizeof(vconf -> vidwin)) == -1)
	{
		perror("VIDIOCSWIN");
		return -1;
	}

	/* map to memory */
	if (ioctl(vconf -> fd, VIDIOCGMBUF, &vconf -> vidmbuf, sizeof(vconf -> vidmbuf)) == -1)
		perror("VIDIOCGMBUF");
	vconf -> img = (unsigned char *)mmap(NULL, vconf -> vidmbuf.size, PROT_READ, MAP_SHARED, vconf -> fd, 0);
	if (!vconf -> img)
	{
		perror("mmap");
		return -1;
	}

	/* set device */
	vconf -> vidmmap.frame = 0;
	vconf -> vidmmap.width = vconf -> vidwin.width;
	vconf -> vidmmap.height = vconf -> vidwin.height;
	vconf -> vidmmap.format = vconf -> vidpic.palette;
}

void close_device(vconfig *vconf)
{
	if (vconf -> fd != -1)
	{
		close(vconf -> fd);
	}
}

unsigned char * take_picture(vconfig *vconf)
{
	unsigned char *pic;

	/* start capture */
	if (ioctl(vconf -> fd, VIDIOCMCAPTURE, &vconf -> vidmmap, sizeof(vconf -> vidmmap)) == -1)
		perror("VIDIOCMCAPTURE");

	/* synchronize frame */
	if (ioctl(vconf -> fd, VIDIOCSYNC, &vconf -> vidmmap.frame, sizeof(vconf -> vidmmap.frame)) == -1)
		perror("VIDIOCSYNC");

	/* return pointer to current frame */
	pic = (unsigned char *)&vconf -> img[vconf -> vidmbuf.offsets[vconf -> vidmmap.frame]];

	/* next time; next frame! */
	vconf -> vidmmap.frame++;
	if (vconf -> vidmmap.frame >= vconf -> vidmbuf.frames)
		vconf -> vidmmap.frame = 0;

	return pic;
}
